<!DOCTYPE html>
<html lang="en-US">

<head>
  <title>Random Ron Swanson</title>

  <meta charset="utf-8">

  <!-- Force latest available IE rendering engine and Chrome Frame (if installed) -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">

  <!-- Mobile Screen Resizing -->
  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <style type="text/css">
    /**
		 * Add box sizing to everything
		 * @link http://www.paulirish.com/2012/box-sizing-border-box-ftw/
		 */
    /* line 38, src/sass/components/_normalize.scss */
    *,
    *:before,
    *:after {
      box-sizing: border-box;
    }

    /**
		 * Layout
		 */
    body {
      font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif;
      font-size: 112.5%;
      margin-left: auto;
      margin-right: auto;
      max-width: 40em;
      width: 88%;
    }

    img {
      height: auto;
      max-width: 100%;
    }

    /**
		 * Button Styles
		 */
    button {
      background-color: #0088cc;
      border: 1px solid #0088cc;
      border-radius: 1px;
      color: #ffffff;
      display: inline-block;
      font-size: 0.9375em;
      font-weight: normal;
      line-height: 1.2;
      margin-right: 0.3125em;
      margin-bottom: 0.3125em;
      padding: 0.5em 0.6875em;
    }

    button:hover,
    button:focus,
    button:active {
      background-color: #005580;
      border-color: #005580;
      color: #ffffff;
      text-decoration: none;
      cursor: pointer;
    }

    /**
		 * Blockquotes
		 */
    blockquote {
      border-left: 0.25em solid #e5e5e5;
      font-style: italic;
      margin: 0 0 1.5625em;
      padding-left: 1em;
      padding-right: 1em;
      quotes: none;
      opacity: 0;
      transition: all .3s;
    }
    blockquote.show { opacity: 1 }

    blockquote:before,
    blockquote:after {
      content: '';
    }

    #quotes {
      min-height: 6rem;
    }
  </style>
</head>

<body>

  <h1>Random Ron Swanson</h1>

  <p><em>Press "More Ron" on to see some brilliant gems</em></p>
  <div id="quotes"></div>

  <div><button data-button>More Ron</button></div>

  <script>
    (function() {

      const xhr = new XMLHttpRequest(),
      quote_wrap = document.querySelector('#quotes');

      /**
       *  Simple XMLHttpRequest
       *  @param {Node} selector Element wrapping the data
       */

      const fromRon = (selector) => {
        // Setup our listener to process request state changes
        xhr.onreadystatechange = function() {

          // if readyState is unsuccessful or selecor doesn't exist bail
          if (xhr.readyState !== 4 || !selector) return;

          // Process our return data
          if (xhr.status >= 200 && xhr.status < 300) {
            let data = JSON.parse(xhr.responseText);
            data.map(d => {
              selector.innerHTML += '<blockquote class="show">' + sanitizeHTML(d) + '</blockquote>'
            })
            // data.forEach(d => {
            //   selector.innerHTML += `<blockquote> ${d} </blockquote>`;
            // })
          } else {
            alert('Something went wrong.  Try again later');
          }
        }

        xhr.open('GET', 'https://ron-swanson-quotes.herokuapp.com/v2/quotes/2');
        xhr.send();
      };

      /**
       * Sanitize and encode all HTML in a user-submitted string
       * (c) 2018 Chris Ferdinandi, MIT License, https://gomakethings.com
       * @param  {String} str  The user-submitted string
       * @return {String}  The sanitized string
       */
      var sanitizeHTML = function(str) {
        var temp = document.createElement('div');
        temp.textContent = str;
        return temp.innerHTML;
      };

      document.addEventListener('click', (e) => {
        e.preventDefault()
        if (e.target.matches('[data-button]')) {
          fromRon(quote_wrap)
          console.log(this);
        }
      })

      // Displays quotes on page load
      fromRon(quote_wrap)

    })();
  </script>

</body>

</html>
